--###############################################################################
--###    Wrote this addon to learn how to do wow addon lua  
--###   attempted to leave as much helpful information in here and sample code as possible.
--###
--###   Libraries used    ACE3 , LibWindow http://www.wowace.com/addons/libwindow-1-1/
--#############################################################################

--Register Ace Libaries
MonklyStuff = LibStub("AceAddon-3.0"):NewAddon("MonklyStuff","AceConsole-3.0","AceEvent-3.0","AceTimer-3.0")
local AceGUI = LibStub("AceGUI-3.0")
local ACD3 = LibStub("AceConfigDialog-3.0")
-- BlizzMenuKey is used to give the entries in the blizzard addon menu list unique names
-- for example many addons use the menu name "Profile or Profiles" to make sure you open to the correct one it needs a unique name
local BlizzMenuKey = "                                          MS"     

--Global Header Name, used in key bindings
_G["BINDING_HEADER_MonklyStuffHeader"] = "Monkly Stuff";

--Create and Register an mini map icon for the addon
local icon = LibStub("LibDBIcon-1.0")


--Create a "Button" Frame
local Button = CreateFrame("Button","MyButton",UIParent,"SecureActionButtonTemplate")
--LibWindow
local LibWin = LibStub("LibWindow-1.1")
--Optional Settings for LibWindow FrameRegister
local LibWinNames = {
   prefix = "MainButton",  -- names become e.g. "myframex", "myframey"
}
function setupMainButton()
	Button:SetWidth(100)
	Button:SetHeight(100)
	Button:SetMovable(true)
	Button.icon = Button:CreateTexture(nil,"CENTER")
	Button.icon:SetTexture("Interface\\Icons\\spell_druid_symbiosis")
	Button.icon:SetAllPoints(Button)		
		
	--Register Frame with LibWin
	LibWin.RegisterConfig(Button, MonklyStuff.db.profile,LibWinNames)
	LibWin.RestorePosition(Button)  -- restores scale also
	
	LibWin.RestorePosition(Button)
end

local tipshown
local lastUp = 0
local color = .60
local upDown = { [false] = "Up", [true] = "Down" }


--ACE DB default profile values, reseting returns the db to these values
local defaults = {
    profile = {
		minimap = {
				hide = false,
			},
        message = "Welcome Home!",
        showInChat = false,
        showOnScreen = true,
		lockButton = false,
		proverbs = {
			enabled = true,
			timer = 1,
			genericproverbs = true,
			dukenukemquotes = true,
		},
    },
}

--Options table used for blizzard addon sub menus
local options = { 
    name = "MonklyStuff",
    handler = MonklyStuff,
    type = "group",
    args = {
		GeneralOptions = {
			order = 1,
			name = "General Frame Options",
			handler = MonklyStuff,
			type = "group",
			args = {
				intro = {
					order = 1,
					type = "description",
					name = "General Configuration options hope you enjoy the addon.",
				},
				scaleButton = {
					order = 2,
					type = "range",
					min = .1,
					max = 2,
					name = "Scale",
					desc = "Scales the size of the button.",
					get = "GetScale",
					set = "SetScale",
				},
				lockButton = {
					order = 1,
					type = "toggle",
					name = "Lock Button",
					desc = "Locks the position of the button.",
					get = "IsLockButton",
					set = "ToggleLockButton",
				},
			},	
		},
		Proverbs = {
			order = 2,
			type = "group",
			name = "Proverb Manager",
			desc = "Proverb Management",
			handler = MonklyStuff,
			childGroups = "tab",
			args = {
				intro = {
					order = 1,
					type = "description",
					name = "Turn on and off different sets of random things to say.",
				},
				Enable = {
					order = 2,
					type = "toggle",
					name = "EnableProverbs",
					desc = "Enable Random Proverbs",
					get = "GetEnabledProverbToggle",
					set = "SetEnabledProverbToggle",
				},
				Timer = {
					order = 3,
					type = "range",
					min = .05,
					max = 20,
					step = .01,
					name = "Proverb Delay",
					desc = "Time between proverb messages. 1 = One Minute.",
					get = "GetProverbTimer",
					set = "SetProverbTimer",
				},
				ProverbSets = {
					order = 4,
					name = "Proverb Sets",
					type = "group",
					args = {
						GenericProverbs = {
							order = 1,
							type = "toggle",
							name = "Generic Proverbs",
							desc = "Enable Generic Proverbs",
							get = "GetGenericProverbToggle",
							set = "SetGenericProverbToggle",
						},
						DukenukemQuotes = {
							order = 2,
							type = "toggle",
							name = "DukeNukem Quotes",
							desc = "Enable DukeNukem Quotes",
							get = "GetDukenukemQuotesToggle",
							set = "SetDukenukemQuotesToggle",
						},
					},
				},
			},
		},				
		MinimapIcon = {
			order = 3,
			type = "group",
			name = "Minimap Icon",
			desc = "Minimap Icon Settings",
			handler = MonklyStuff,
			args = {
				intro = {
					order = 1,
					type = "description",
					name = "Turn on and off the minimap icon from here.",
				},
				minimap = {
					order = 2,
						type = "toggle",
						name = "Show Minimap Icon",
						desc = "Show Minimap Icon",				
						get = function(info) return not MonklyStuff.db.profile.minimap.hide end,
							set = function(info,val) 
								MonklyStuff.db.profile.minimap.hide = not val
						MonklyStuff:ToggleIcon()
								end,
				},
			},
		},

    },	
}


local function GetTipAnchor(frame)
	local x,y = frame:GetCenter()
	if not x or not y then return "TOPLEFT", "BOTTOMLEFT" end
	local hhalf = (x > UIParent:GetWidth()*2/3) and "RIGHT" or (x < UIParent:GetWidth()/3) and "LEFT" or ""
	local vhalf = (y > UIParent:GetHeight()/2) and "TOP" or "BOTTOM"
	return vhalf..hhalf, frame, (vhalf == "TOP" and "BOTTOM" or "TOP")..hhalf
end

local MonklyStuffLDB = LibStub("LibDataBroker-1.1"):NewDataObject("MonklyStuff", {
	type = "data source",
	text = "MonklyStuff",
	icon = "Interface\\Icons\\spell_druid_symbiosis",
	
	OnClick = function(frame, button)
		GameTooltip:Hide()
		if button == "RightButton" then
			if MonklyStuff.optionsFrames.MonklyStuff:IsVisible() then
				InterfaceOptionsFrame_Show()
			else
				--InterfaceOptionsFrame_OpenToCategory(MonklyStuff.optionsFrames.Profiles)
				InterfaceOptionsFrame_OpenToCategory("Monkly Stuff")
			end
		end
	end,
	
	OnEnter = function(MonklyStuff)
		tipshown = MonklyStuff
		GameTooltip:SetOwner(MonklyStuff, "ANCHOR_NONE")
		GameTooltip:SetPoint(GetTipAnchor(MonklyStuff))
		GameTooltip:ClearLines()
		--GameTooltip:AddLine(GetAddOnMetadata("MonklyStuff", "Title").." "..GetAddOnMetadata("MonklyStuff", "Version").." "..GetAddOnMetadata("MonklyStuff", "Author"))
		GameTooltip:AddLine(GetAddOnMetadata("MonklyStuff", "Title"))
		GameTooltip:AddLine(" ")	
		GameTooltip:AddLine("Hint: Right-Click to open Options", 0, 1, 0)
		GameTooltip:AddTexture("Interface\\Icons\\spell_druid_symbiosis")	
		GameTooltip:Show()
	end,

	OnLeave = function()
		GameTooltip:Hide()
		tipshown = nil	
	end,
})

--Getters and Setters for variables in the Add-on Class  ACE uses these to build up options frames as well
--msg
function MonklyStuff:GetMessage(info)
    return MonklyStuff.db.profile.message
end
function MonklyStuff:SetMessage(info, newValue)
    MonklyStuff.db.profile.message = newValue
end
--show msg in chat
function MonklyStuff:IsShowInChat(info)
    return MonklyStuff.db.profile.showInChat
end
function MonklyStuff:ToggleShowInChat(info, value)
    MonklyStuff.db.profile.showInChat = value
end
--show msg in frame
function MonklyStuff:IsShowOnScreen(info)
    return MonklyStuff.db.profile.showOnScreen
end
function MonklyStuff:ToggleShowOnScreen(info, value)
    MonklyStuff.db.profile.showOnScreen = value
end
--lock button
function MonklyStuff:IsLockButton(info)
    return MonklyStuff.db.profile.lockButton
end
function MonklyStuff:ToggleLockButton(info, value)
    MonklyStuff.db.profile.lockButton = value
end
--Scale
function MonklyStuff:GetScale(info)
    return Button:GetScale() 
end
function MonklyStuff:SetScale(info, value)
	LibWin.SetScale(Button, value)
end
--------------------Proverbs
--Enabled Proverbs
function MonklyStuff:GetEnabledProverbToggle(info)
    return MonklyStuff.db.profile.proverbs.enabled
end
function MonklyStuff:SetEnabledProverbToggle(info, value)
    MonklyStuff.db.profile.proverbs.enabled = value
	if value == true then
		self.testTimer = self:ScheduleRepeatingTimer("TimerFeedback", 5)
	else
		self:CancelTimer(self.testTimer)
	end 
end
--Generic Proverbs
function MonklyStuff:GetGenericProverbToggle(info)
    return MonklyStuff.db.profile.proverbs.genericproverbs
end
function MonklyStuff:SetGenericProverbToggle(info, value)
    MonklyStuff.db.profile.proverbs.genericproverbs = value
end
--Dukenukem
function MonklyStuff:GetDukenukemQuotesToggle(info)
    return MonklyStuff.db.profile.proverbs.dukenukemquotes
end
function MonklyStuff:SetDukenukemQuotesToggle(info, value)
    MonklyStuff.db.profile.proverbs.dukenukemquotes = value
end
--timer
function MonklyStuff:GetProverbTimer(info)
    return MonklyStuff.db.profile.proverbs.timer
end
function MonklyStuff:SetProverbTimer(info, value)
    MonklyStuff.db.profile.proverbs.timer = value
	self.timerCount = 0
end


--------------------------------------------------------------------------------------------------------
function MonklyStuff:OnInitialize()
	SetupOptions()
end

function MonklyStuff:UpdateProfile()
	MonklyStuff.db.global.profileupdate = true
	ReloadUI()
end

function SetupOptions(self)
	--Load ACE Profile DB
	MonklyStuff.db = LibStub("AceDB-3.0"):New("MonklyStuffDB", defaults, "Default")
	MonklyStuff.globaldb = LibStub("AceDB-3.0"):New("MonklyStuffDB",globalvars, "Default")

	--Register Profile Events
    MonklyStuff.db.RegisterCallback(MonklyStuff, "OnProfileChanged", "UpdateProfile")
    MonklyStuff.db.RegisterCallback(MonklyStuff, "OnProfileCopied", "UpdateProfile")
    MonklyStuff.db.RegisterCallback(MonklyStuff,"OnProfileReset", "UpdateProfile")	
	
	--AceDBOptions adding in the profile management options to the options table
	--used in conjunction with the Blizzard Addon Interface menu
	options.args.profile = LibStub("AceDBOptions-3.0"):GetOptionsTable(MonklyStuff.db)
	
	
	LibStub("AceConfig-3.0"):RegisterOptionsTable("MonklyStuff", options, "Monkly Stuff")
	LibStub("AceConfigRegistry-3.0"):RegisterOptionsTable("MonklyStuff Profiles",options.args.profile)
	LibStub("AceConfigRegistry-3.0"):RegisterOptionsTable("MonklyStuff Proverbs",options.args.Proverbs)
	LibStub("AceConfigRegistry-3.0"):RegisterOptionsTable("MonklyStuff Minimap Icon",options.args.MinimapIcon)	
 	LibStub("AceConfigRegistry-3.0"):RegisterOptionsTable("MonklyStuff Blizz", options.args.GeneralOptions)	

	
	--Create optionsFrames Value, not entirely sure why this works the way it does	
	-- I believe this is a short cut to reference the menu in the blizzard interface
	MonklyStuff.optionsFrames = {}	
	--http://www.wowace.com/addons/ace3/pages/api/ace-config-dialog-3-0/
	--(registered option table name, display text, parent frame,path to table)
	MonklyStuff.optionsFrames.MonklyStuff = ACD3:AddToBlizOptions("MonklyStuff Blizz","Monkly Stuff")
	MonklyStuff.optionsFrames.ShowWhen = ACD3:AddToBlizOptions("MonklyStuff Minimap Icon","Minimap Icon"..BlizzMenuKey,"Monkly Stuff")	
	MonklyStuff.optionsFrames.ShowWhen = ACD3:AddToBlizOptions("MonklyStuff Proverbs","Proverbs"..BlizzMenuKey ,"Monkly Stuff")
	MonklyStuff.optionsFrames.ShowWhen = ACD3:AddToBlizOptions("MonklyStuff Profiles", "Profiles"..BlizzMenuKey, "Monkly Stuff")
		
	--Register Chat commands to interact with options
	MonklyStuff:RegisterChatCommand("monklystuff", "ChatCommand")
    MonklyStuff:RegisterChatCommand("ms", "ChatCommand")	
end


function MonklyStuff:ChatCommand(input)
    if not input or input:trim() == "" then
        InterfaceOptionsFrame_OpenToCategory("Monkly Stuff")
    else
        LibStub("AceConfigCmd-3.0").HandleCommand(MonklyStuff, "ms", "MonklyStuff", input)
    end
end

function MonklyStuff:OnEnable()
	setupMainButton()

	--Check if a profile was refreshed
	if MonklyStuff.db.global.profileupdate == true then
		MonklyStuff.db.global.profileupdate = false
		InterfaceOptionsFrame_OpenToCategory("Profiles"..BlizzMenuKey)
	end
		
	--Create minimap icon if needed
	MonklyStuff.db.profile.minimap = MonklyStuff.db.profile.minimap or {}
	icon:Register("MonklyStuff", MonklyStuffLDB, MonklyStuff.db.profile.minimap)
	MonklyStuff:ToggleIcon()

	--Register Events
	MonklyStuff:RegisterEvent("ZONE_CHANGED")	

	--Proverb Timer Stuff
	self.timerCount = 0
	if MonklyStuff.db.profile.proverbs.enabled == true then
		self.testTimer = self:ScheduleRepeatingTimer("TimerFeedback", 5)
	end
end


function MonklyStuff:TimerFeedback()
	self.timerCount = self.timerCount + 5
	self:CancelTimer(self.testTimer)
	--print(self.timerCount)
	waitseconds = MonklyStuff.db.profile.proverbs.timer * 60
	--print(waitseconds)
	if self.timerCount >= waitseconds then
		self.timerCount = 0
		--http://wowprogramming.com/docs/api/SendChatMessage
		SendChatMessage(RanProverb() ,"SAY");
	end
	if MonklyStuff.db.profile.proverbs.enabled == true then
		self.testTimer = self:ScheduleRepeatingTimer("TimerFeedback", 5)
	end
end

function MonklyStuff:OnDisable()
    -- Called when the addon is disabled
end


function MonklyStuff:ZONE_CHANGED()
    MonklyStuff:Print("zone changed")
	if GetBindLocation() == GetSubZoneText() then
        if MonklyStuff.db.profile.showInChat then
            MonklyStuff:Print(MonklyStuff.db.profile.message)
        end

        if MonklyStuff.db.profile.showOnScreen then
            UIErrorsFrame:AddMessage(MonklyStuff.db.profile.message, 1.0, 1.0, 1.0, 5.0)
        end
    end
end

local function show(text, color)
  DEFAULT_CHAT_FRAME:AddMessage(text, color, color, color)
end

function MonklyStuff:ToggleIcon()
	if MonklyStuff.db.profile.minimap.hide then
    	icon:Hide("MonklyStuff")
  	else
		icon:Show("MonklyStuff")
 	end	
end

------------------------BUTTON EVENTS-----------------------------------
--Clicks
Button:RegisterForClicks("AnyUp", "AnyDown")
Button:SetScript("OnClick", function(MonklyStuff, button, down)
  color = color + 0.1
  show(format("OnClick: %s %s", button, upDown[down]), color, color, color)
end)
--Drags
Button:RegisterForDrag("LeftButton")
Button:SetScript("OnDragStop",function()
	Button:StopMovingOrSizing()
	LibWin.SavePosition(Button)
end)
Button:SetScript("OnDragStart",function()
	if not MonklyStuff.db.profile.lockButton then
		Button:StartMoving()
	end
end)
---------------------END BUTTON EVENTS-----------------------------------





